import { Pool, EosioActionObject, EosioAuthorizationObject } from "../types";
export declare class ActionGenerator {
    readonly contract: string;
    constructor(contract: string);
    addWhiteList(authorization: EosioAuthorizationObject[], category: number, pools: Pool[]): Promise<EosioActionObject[]>;
    removeWhiteList(authorization: EosioAuthorizationObject[], category: number): Promise<EosioActionObject[]>;
    createProposal(authorization: EosioAuthorizationObject[], category: number, proposer: string, new_contract: string, description: string, vote_start: string, vote_end: string): Promise<EosioActionObject[]>;
    approveProposal(authorization: EosioAuthorizationObject[], proposal_id: number): Promise<EosioActionObject[]>;
    executeProposal(authorization: EosioAuthorizationObject[], proposal_id: number): Promise<EosioActionObject[]>;
    vote(authorization: EosioAuthorizationObject[], voter: string, proposal_id: string, option: string): Promise<EosioActionObject[]>;
    claimRewards(authorization: EosioAuthorizationObject[], category: number): Promise<EosioActionObject[]>;
    protected _pack(account: string, authorization: EosioAuthorizationObject[], name: string, data: any): EosioActionObject[];
}
