"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ActionGenerator = void 0;
/* tslint:disable:variable-name */
class ActionGenerator {
    constructor(contract) {
        this.contract = contract;
    }
    async addWhiteList(authorization, category, pools) {
        return this._pack(this.contract, authorization, "addwhlst", {
            category,
            pools,
        });
    }
    async removeWhiteList(authorization, category) {
        return this._pack(this.contract, authorization, "rmvwhlst", {
            category,
        });
    }
    async createProposal(authorization, category, proposer, new_contract, description, vote_start, vote_end) {
        return this._pack(this.contract, authorization, "crtproposal", {
            category,
            proposer,
            new_contract,
            description,
            vote_start,
            vote_end,
        });
    }
    async approveProposal(authorization, proposal_id) {
        return this._pack(this.contract, authorization, "appcntprp", {
            proposal_id,
        });
    }
    async executeProposal(authorization, proposal_id) {
        return this._pack(this.contract, authorization, "execcntprp", {
            proposal_id,
        });
    }
    async vote(authorization, voter, proposal_id, option) {
        return this._pack(this.contract, authorization, "vote", {
            voter,
            proposal_id,
            option,
        });
    }
    async claimRewards(authorization, category) {
        return this._pack(this.contract, authorization, "claimrwds", {
            category,
        });
    }
    _pack(account, authorization, name, data) {
        return [{ account, name, authorization, data }];
    }
}
exports.ActionGenerator = ActionGenerator;
